﻿Imports CustomerManagement.Core.Model.ApplicationEvents
Imports CustomerManagement.Core.Services
Imports Shareds

Namespace CustomerManagement.Core.Model
    Public Class Customer
        Public Shared Function Create(ByVal name As String, ByVal source As String) As Customer
            Return New Customer(name, source)
        End Function
        Private Sub New(ByVal name As String, ByVal source As String)
            Id = Guid.NewGuid()
            Me.Name = name
            InitialDate = Date.UtcNow
            ModifiedDate = Date.UtcNow
            Me.Source = source
            PublishEvent(True)
        End Sub

        Private privateId As Guid
        Public Property Id As Guid
            Get
                Return privateId
            End Get
            Private Set(ByVal value As Guid)
                privateId = value
            End Set
        End Property
        Private privateName As String
        Public Property Name As String
            Get
                Return privateName
            End Get
            Private Set(ByVal value As String)
                privateName = value
            End Set
        End Property
        Private privateInitialDate As Date
        Public Property InitialDate As Date
            Get
                Return privateInitialDate
            End Get
            Private Set(ByVal value As Date)
                privateInitialDate = value
            End Set
        End Property
        Private privateModifiedDate As Date
        Public Property ModifiedDate As Date
            Get
                Return privateModifiedDate
            End Get
            Private Set(ByVal value As Date)
                privateModifiedDate = value
            End Set
        End Property

        Private privateSource As String
        Public Property Source As String
            Get
                Return privateSource
            End Get
            Private Set(ByVal value As String)
                privateSource = value
            End Set
        End Property
        Public Sub FixName(ByVal newName As String)

            Name = newName
            ModifiedDate = Date.UtcNow
            PublishEvent(False)

        End Sub
        Private Sub PublishEvent(ByVal isNew As Boolean)
            Dim dto = CustomerDto.Create(Id, Name)
            DomainEvents.Raise(New CustomerUpdatedEvent(dto, isNew))
        End Sub
    End Class
End Namespace