﻿'From Pluralsight Domain-Driven Design Fundamentals Course (bit.ly/PS-DDD)
Imports Shareds.Interfaces
Imports StructureMap

Namespace Shareds

    ''' <summary>
    ''' http://msdn.microsoft.com/en-gb/magazine/ee236415.aspx#id0400046
    ''' </summary>
    Public NotInheritable Class DomainEvents

        <ThreadStatic>
        Private Shared actions As List(Of Action(Of IDomainEvent))

        Private Sub New()
        End Sub
        Shared Sub New()

            Container = StructureMap.ObjectFactory.Container

        End Sub

        Public Shared Property Container As IContainer
        Public Shared Sub Register(Of T As IDomainEvent)(ByVal callback As Action(Of IDomainEvent))

            If actions Is Nothing Then

                actions = New List(Of Action(Of IDomainEvent))

            End If
            actions.Add(callback)

        End Sub

        Public Shared Sub ClearCallbacks()

            actions = Nothing

        End Sub

        Public Shared Sub Raise(Of T As IDomainEvent)(ByVal args As T)

            For Each handler In Container.GetAllInstances(Of IHandle(Of T))()

                handler.Handle(args)

            Next handler

            If actions IsNot Nothing Then

                For Each action In actions

                    If TypeOf action Is Action(Of IDomainEvent) Then

                        CType(action, Action(Of IDomainEvent))(args)

                    End If

                Next action

            End If

        End Sub

    End Class

End Namespace
